/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletIndustrialAnalogOut;

/**
 * Passes through actions of the Industrial Analog Out Bricklet.
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialAnalogOutActions implements ThingActions, IBrickletIndustrialAnalogOutActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

    private static IBrickletIndustrialAnalogOutActions invokeMethodOf(@Nullable ThingActions actions) {
        if (actions == null) {
            throw new IllegalArgumentException("actions cannot be null");
        }
        if (actions.getClass().getName().equals(BrickletIndustrialAnalogOutActions.class.getName())) {
            if (actions instanceof IBrickletIndustrialAnalogOutActions) {
                return (IBrickletIndustrialAnalogOutActions) actions;
            } else {
                return (IBrickletIndustrialAnalogOutActions) Proxy.newProxyInstance(IBrickletIndustrialAnalogOutActions.class.getClassLoader(),
                        new Class[] { IBrickletIndustrialAnalogOutActions.class }, (Object proxy, Method method, Object[] args) -> {
                            Method m = actions.getClass().getDeclaredMethod(method.getName(),
                                    method.getParameterTypes());
                            return m.invoke(actions, args);
                        });
            }
        }
        throw new IllegalArgumentException("Actions is not an instance of BrickletIndustrialAnalogOutActions");
    }

        @Override
    @RuleAction(label = "Enable")
    public void brickletIndustrialAnalogOutEnable(
            ) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialAnalogOutWrapper dev = ((@Nullable BrickletIndustrialAnalogOutWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.enable();
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialAnalogOutEnabled")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialAnalogOutEnabled"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialAnalogOutEnable(@Nullable ThingActions actions) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialAnalogOutEnable();
    }

    @Override
    @RuleAction(label = "Disable")
    public void brickletIndustrialAnalogOutDisable(
            ) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialAnalogOutWrapper dev = ((@Nullable BrickletIndustrialAnalogOutWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.disable();
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialAnalogOutEnabled")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialAnalogOutEnabled"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialAnalogOutDisable(@Nullable ThingActions actions) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialAnalogOutDisable();
    }


    @Override
    @RuleAction(label = "Is Enabled")
    public @ActionOutput(name = "enabled", type="boolean")
           Map<String, Object> brickletIndustrialAnalogOutIsEnabled(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialAnalogOutWrapper dev = ((@Nullable BrickletIndustrialAnalogOutWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        boolean value = dev.isEnabled();
        
        result.put("enabled", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialAnalogOutIsEnabled(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialAnalogOutIsEnabled();
    }


    @Override
    @RuleAction(label = "Get Voltage")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> brickletIndustrialAnalogOutGetVoltage(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialAnalogOutWrapper dev = ((@Nullable BrickletIndustrialAnalogOutWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getVoltage();
        
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialAnalogOutGetVoltage(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialAnalogOutGetVoltage();
    }


    @Override
    @RuleAction(label = "Get Current")
    public @ActionOutput(name = "current", type="int")
           Map<String, Object> brickletIndustrialAnalogOutGetCurrent(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialAnalogOutWrapper dev = ((@Nullable BrickletIndustrialAnalogOutWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getCurrent();
        
        result.put("current", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialAnalogOutGetCurrent(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialAnalogOutGetCurrent();
    }


    @Override
    @RuleAction(label = "Get Configuration")
    public @ActionOutput(name = "voltageRange", type="short")
           @ActionOutput(name = "currentRange", type="short")
           Map<String, Object> brickletIndustrialAnalogOutGetConfiguration(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialAnalogOutWrapper dev = ((@Nullable BrickletIndustrialAnalogOutWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialAnalogOut.Configuration value = dev.getConfiguration();
        
        result.put("voltageRange", value.voltageRange);
        result.put("currentRange", value.currentRange);
        return result;
    }

    public static Map<String, Object> brickletIndustrialAnalogOutGetConfiguration(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialAnalogOutGetConfiguration();
    }


    @Override
    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIndustrialAnalogOutGetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialAnalogOutWrapper dev = ((@Nullable BrickletIndustrialAnalogOutWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialAnalogOut.Identity value = dev.getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialAnalogOutGetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialAnalogOutGetIdentity();
    }
}
