/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletIndustrialDual020mAV2;

/**
 * Passes through actions of the Industrial Dual 0-20mA Bricklet 2.0.
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDual020mAV2Actions implements ThingActions, IBrickletIndustrialDual020mAV2Actions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

    private static IBrickletIndustrialDual020mAV2Actions invokeMethodOf(@Nullable ThingActions actions) {
        if (actions == null) {
            throw new IllegalArgumentException("actions cannot be null");
        }
        if (actions.getClass().getName().equals(BrickletIndustrialDual020mAV2Actions.class.getName())) {
            if (actions instanceof IBrickletIndustrialDual020mAV2Actions) {
                return (IBrickletIndustrialDual020mAV2Actions) actions;
            } else {
                return (IBrickletIndustrialDual020mAV2Actions) Proxy.newProxyInstance(IBrickletIndustrialDual020mAV2Actions.class.getClassLoader(),
                        new Class[] { IBrickletIndustrialDual020mAV2Actions.class }, (Object proxy, Method method, Object[] args) -> {
                            Method m = actions.getClass().getDeclaredMethod(method.getName(),
                                    method.getParameterTypes());
                            return m.invoke(actions, args);
                        });
            }
        }
        throw new IllegalArgumentException("Actions is not an instance of BrickletIndustrialDual020mAV2Actions");
    }

    
    @Override
    @RuleAction(label = "Get Current")
    public @ActionOutput(name = "current", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetCurrent(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getCurrent(channel);
        
        result.put("current", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetCurrent(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetCurrent(channel);
    }


    @Override
    @RuleAction(label = "Get Channel LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDConfig(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getChannelLEDConfig(channel);
        
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDConfig(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetChannelLEDConfig(channel);
    }


    @Override
    @RuleAction(label = "Get Channel LED Status Config")
    public @ActionOutput(name = "min", type="int")
           @ActionOutput(name = "max", type="int")
           @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDStatusConfig(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialDual020mAV2.ChannelLEDStatusConfig value = dev.getChannelLEDStatusConfig(channel);
        
        result.put("min", value.min);
        result.put("max", value.max);
        result.put("config", value.config);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetChannelLEDStatusConfig(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetChannelLEDStatusConfig(channel);
    }


    @Override
    @RuleAction(label = "Get Sample Rate")
    public @ActionOutput(name = "rate", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetSampleRate(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getSampleRate();
        
        result.put("rate", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetSampleRate(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetSampleRate();
    }


    @Override
    @RuleAction(label = "Get Gain")
    public @ActionOutput(name = "gain", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetGain(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getGain();
        
        result.put("gain", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetGain(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetGain();
    }


    @Override
    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type="long")
           Map<String, Object> brickletIndustrialDual020mAV2ReadUID(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        long value = dev.readUID();
        
        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2ReadUID(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2ReadUID();
    }


    @Override
    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetChipTemperature(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getChipTemperature();
        
        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetChipTemperature(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetChipTemperature();
    }


    @Override
    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetStatusLEDConfig(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getStatusLEDConfig();
        
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetStatusLEDConfig(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetStatusLEDConfig();
    }


    @Override
    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type="long")
           @ActionOutput(name = "errorCountMessageChecksum", type="long")
           @ActionOutput(name = "errorCountFrame", type="long")
           @ActionOutput(name = "errorCountOverflow", type="long")
           Map<String, Object> brickletIndustrialDual020mAV2GetSPITFPErrorCount(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialDual020mAV2.SPITFPErrorCount value = dev.getSPITFPErrorCount();
        
        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetSPITFPErrorCount(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetSPITFPErrorCount();
    }

    @Override
    @RuleAction(label = "Reset")
    public void brickletIndustrialDual020mAV2Reset(
            ) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.reset();
        
    }

    public static void brickletIndustrialDual020mAV2Reset(@Nullable ThingActions actions) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialDual020mAV2Reset();
    }


    @Override
    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIndustrialDual020mAV2GetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDual020mAV2Wrapper dev = ((@Nullable BrickletIndustrialDual020mAV2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialDual020mAV2.Identity value = dev.getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAV2GetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDual020mAV2GetIdentity();
    }
}
