/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the IMU Brick 2.0.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickIMUV2Actions {

    public Map<String, Object> brickIMUV2GetOrientation() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetLinearAcceleration() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetGravityVector() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetQuaternion() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetAllData() throws TinkerforgeException;

    public void brickIMUV2LedsOn() throws TinkerforgeException;

    public void brickIMUV2LedsOff() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetAcceleration() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetMagneticField() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetAngularVelocity() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetTemperature() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetSensorConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetSensorFusionMode() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetIdentity() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2IsStatusLEDEnabled() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetSendTimeoutCount(short communicationMethod) throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetSPITFPBaudrateConfig() throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetSPITFPErrorCount(char brickletPort) throws TinkerforgeException;

    public Map<String, Object> brickIMUV2GetSPITFPBaudrate(char brickletPort) throws TinkerforgeException;;
}
