/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Master Brick.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickMasterActions {

    public Map<String, Object> brickMasterGetStackVoltage() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetStackCurrent() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetExtensionType(short extension) throws TinkerforgeException;

    public Map<String, Object> brickMasterIsChibiPresent() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChibiAddress() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChibiMasterAddress() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChibiSlaveAddress(short num) throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChibiSignalStrength() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChibiErrorLog() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChibiFrequency() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChibiChannel() throws TinkerforgeException;

    public Map<String, Object> brickMasterIsRS485Present() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetRS485Address() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetRS485SlaveAddress(short num) throws TinkerforgeException;

    public Map<String, Object> brickMasterGetRS485ErrorLog() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetRS485Configuration() throws TinkerforgeException;

    public Map<String, Object> brickMasterIsWifiPresent() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiEncryption() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiStatus() throws TinkerforgeException;

    public void brickMasterRefreshWifiStatus() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiCertificate(int index) throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiPowerMode() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiBufferInfo() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiRegulatoryDomain() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetLongWifiKey() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiHostname() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifiAuthenticationSecret() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetUSBVoltage() throws TinkerforgeException;

    public Map<String, Object> brickMasterIsEthernetPresent() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetEthernetConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetEthernetStatus() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetEthernetWebsocketConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetEthernetAuthenticationSecret() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetConnectionType() throws TinkerforgeException;

    public Map<String, Object> brickMasterIsWifi2Present() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2AuthenticationSecret() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2Configuration() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2Status() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2ClientConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2ClientHostname() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2APConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2FirmwareVersion() throws TinkerforgeException;

    public void brickMasterEnableWifi2StatusLED() throws TinkerforgeException;

    public void brickMasterDisableWifi2StatusLED() throws TinkerforgeException;

    public Map<String, Object> brickMasterIsWifi2StatusLEDEnabled() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2MeshConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2MeshRouterSSID() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2MeshCommonStatus() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2MeshClientStatus() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetWifi2MeshAPStatus() throws TinkerforgeException;

    public void brickMasterSetBrickletsEnabled(boolean brickletsEnabled) throws TinkerforgeException;

    public Map<String, Object> brickMasterGetBrickletsEnabled() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetIdentity() throws TinkerforgeException;

    public Map<String, Object> brickMasterIsStatusLEDEnabled() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetSendTimeoutCount(short communicationMethod) throws TinkerforgeException;

    public Map<String, Object> brickMasterGetSPITFPBaudrateConfig() throws TinkerforgeException;

    public Map<String, Object> brickMasterGetSPITFPErrorCount(char brickletPort) throws TinkerforgeException;

    public Map<String, Object> brickMasterGetSPITFPBaudrate(char brickletPort) throws TinkerforgeException;;
}
