/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Servo Brick.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickServoActions {

    public void brickServoEnable(short servoNum) throws TinkerforgeException;

    public void brickServoDisable(short servoNum) throws TinkerforgeException;

    public Map<String, Object> brickServoIsEnabled(short servoNum) throws TinkerforgeException;

    public void brickServoSetPosition(short servoNum, short position) throws TinkerforgeException;

    public Map<String, Object> brickServoGetPosition(short servoNum) throws TinkerforgeException;

    public Map<String, Object> brickServoGetCurrentPosition(short servoNum) throws TinkerforgeException;

    public void brickServoSetVelocity(short servoNum, int velocity) throws TinkerforgeException;

    public Map<String, Object> brickServoGetVelocity(short servoNum) throws TinkerforgeException;

    public Map<String, Object> brickServoGetCurrentVelocity(short servoNum) throws TinkerforgeException;

    public void brickServoSetAcceleration(short servoNum, int acceleration) throws TinkerforgeException;

    public Map<String, Object> brickServoGetAcceleration(short servoNum) throws TinkerforgeException;

    public void brickServoSetOutputVoltage(int voltage) throws TinkerforgeException;

    public Map<String, Object> brickServoGetOutputVoltage() throws TinkerforgeException;

    public void brickServoSetPulseWidth(short servoNum, int min, int max) throws TinkerforgeException;

    public Map<String, Object> brickServoGetPulseWidth(short servoNum) throws TinkerforgeException;

    public void brickServoSetDegree(short servoNum, short min, short max) throws TinkerforgeException;

    public Map<String, Object> brickServoGetDegree(short servoNum) throws TinkerforgeException;

    public void brickServoSetPeriod(short servoNum, int period) throws TinkerforgeException;

    public Map<String, Object> brickServoGetPeriod(short servoNum) throws TinkerforgeException;

    public Map<String, Object> brickServoGetServoCurrent(short servoNum) throws TinkerforgeException;

    public Map<String, Object> brickServoGetOverallCurrent() throws TinkerforgeException;

    public Map<String, Object> brickServoGetStackInputVoltage() throws TinkerforgeException;

    public Map<String, Object> brickServoGetExternalInputVoltage() throws TinkerforgeException;

    public Map<String, Object> brickServoGetMinimumVoltage() throws TinkerforgeException;

    public Map<String, Object> brickServoGetIdentity() throws TinkerforgeException;

    public Map<String, Object> brickServoIsStatusLEDEnabled() throws TinkerforgeException;

    public Map<String, Object> brickServoGetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickServoGetSendTimeoutCount(short communicationMethod) throws TinkerforgeException;

    public Map<String, Object> brickServoGetSPITFPBaudrateConfig() throws TinkerforgeException;

    public Map<String, Object> brickServoGetSPITFPErrorCount(char brickletPort) throws TinkerforgeException;

    public Map<String, Object> brickServoGetSPITFPBaudrate(char brickletPort) throws TinkerforgeException;;
}
