/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Silent Stepper Brick.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickSilentStepperActions {

    public void brickSilentStepperSetMaxVelocity(int velocity) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetMaxVelocity() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetCurrentVelocity() throws TinkerforgeException;

    public void brickSilentStepperSetSpeedRamping(int acceleration, int deacceleration) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetSpeedRamping() throws TinkerforgeException;

    public void brickSilentStepperFullBrake() throws TinkerforgeException;

    public void brickSilentStepperSetSteps(int steps) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetSteps() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetRemainingSteps() throws TinkerforgeException;

    public void brickSilentStepperDriveForward() throws TinkerforgeException;

    public void brickSilentStepperDriveBackward() throws TinkerforgeException;

    public void brickSilentStepperStop() throws TinkerforgeException;

    public void brickSilentStepperSetMotorCurrent(int current) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetMotorCurrent() throws TinkerforgeException;

    public void brickSilentStepperEnable() throws TinkerforgeException;

    public void brickSilentStepperDisable() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperIsEnabled() throws TinkerforgeException;

    public void brickSilentStepperSetBasicConfiguration(int standstillCurrent, int motorRunCurrent, int standstillDelayTime, int powerDownTime, int stealthThreshold, int coolstepThreshold, int classicThreshold, boolean highVelocityChopperMode) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetBasicConfiguration() throws TinkerforgeException;

    public void brickSilentStepperSetCurrentPosition(int position) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetCurrentPosition() throws TinkerforgeException;

    public void brickSilentStepperSetTargetPosition(int position) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetTargetPosition() throws TinkerforgeException;

    public void brickSilentStepperSetStepConfiguration(short stepResolution, boolean interpolation) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetStepConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetStackInputVoltage() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetExternalInputVoltage() throws TinkerforgeException;

    public void brickSilentStepperSetSpreadcycleConfiguration(short slowDecayDuration, boolean enableRandomSlowDecay, short fastDecayDuration, short hysteresisStartValue, byte hysteresisEndValue, byte sineWaveOffset, short chopperMode, short comparatorBlankTime, boolean fastDecayWithoutComparator) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetSpreadcycleConfiguration() throws TinkerforgeException;

    public void brickSilentStepperSetStealthConfiguration(boolean enableStealth, short amplitude, short gradient, boolean enableAutoscale, boolean forceSymmetric, short freewheelMode) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetStealthConfiguration() throws TinkerforgeException;

    public void brickSilentStepperSetCoolstepConfiguration(short minimumStallguardValue, short maximumStallguardValue, short currentUpStepWidth, short currentDownStepWidth, short minimumCurrent, byte stallguardThresholdValue, short stallguardMode) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetCoolstepConfiguration() throws TinkerforgeException;

    public void brickSilentStepperSetMiscConfiguration(boolean disableShortToGroundProtection, short synchronizePhaseFrequency) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetMiscConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetDriverStatus() throws TinkerforgeException;

    public void brickSilentStepperSetTimeBase(long timeBase) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetTimeBase() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetAllData() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetAllDataPeriod() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetIdentity() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperIsStatusLEDEnabled() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetSendTimeoutCount(short communicationMethod) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetSPITFPBaudrateConfig() throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetSPITFPErrorCount(char brickletPort) throws TinkerforgeException;

    public Map<String, Object> brickSilentStepperGetSPITFPBaudrate(char brickletPort) throws TinkerforgeException;;
}
