/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Stepper Brick.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickStepperActions {

    public void brickStepperSetMaxVelocity(int velocity) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetMaxVelocity() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetCurrentVelocity() throws TinkerforgeException;

    public void brickStepperSetSpeedRamping(int acceleration, int deacceleration) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetSpeedRamping() throws TinkerforgeException;

    public void brickStepperFullBrake() throws TinkerforgeException;

    public void brickStepperSetSteps(int steps) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetSteps() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetRemainingSteps() throws TinkerforgeException;

    public void brickStepperDriveForward() throws TinkerforgeException;

    public void brickStepperDriveBackward() throws TinkerforgeException;

    public void brickStepperStop() throws TinkerforgeException;

    public void brickStepperSetMotorCurrent(int current) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetMotorCurrent() throws TinkerforgeException;

    public void brickStepperEnable() throws TinkerforgeException;

    public void brickStepperDisable() throws TinkerforgeException;

    public Map<String, Object> brickStepperIsEnabled() throws TinkerforgeException;

    public void brickStepperSetCurrentPosition(int position) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetCurrentPosition() throws TinkerforgeException;

    public void brickStepperSetTargetPosition(int position) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetTargetPosition() throws TinkerforgeException;

    public void brickStepperSetStepMode(short mode) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetStepMode() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetStackInputVoltage() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetExternalInputVoltage() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetCurrentConsumption() throws TinkerforgeException;

    public void brickStepperSetDecay(int decay) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetDecay() throws TinkerforgeException;

    public void brickStepperSetSyncRect(boolean syncRect) throws TinkerforgeException;

    public Map<String, Object> brickStepperIsSyncRect() throws TinkerforgeException;

    public void brickStepperSetTimeBase(long timeBase) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetTimeBase() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetAllData() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetAllDataPeriod() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetIdentity() throws TinkerforgeException;

    public Map<String, Object> brickStepperIsStatusLEDEnabled() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetSendTimeoutCount(short communicationMethod) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetSPITFPBaudrateConfig() throws TinkerforgeException;

    public Map<String, Object> brickStepperGetSPITFPErrorCount(char brickletPort) throws TinkerforgeException;

    public Map<String, Object> brickStepperGetSPITFPBaudrate(char brickletPort) throws TinkerforgeException;;
}
