/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the E-Paper 296x128 Bricklet.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletEPaper296x128Actions {

    public void brickletEPaper296x128Draw() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetDrawStatus() throws TinkerforgeException;

    public void brickletEPaper296x128WriteBlackWhite(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128ReadBlackWhite(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException;

    public void brickletEPaper296x128WriteColor(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128ReadColor(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException;

    public void brickletEPaper296x128FillDisplay(int color) throws TinkerforgeException;

    public void brickletEPaper296x128DrawText(int positionX, int positionY, int font, int color, int orientation, String text) throws TinkerforgeException;

    public void brickletEPaper296x128DrawLine(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, int color) throws TinkerforgeException;

    public void brickletEPaper296x128DrawBox(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean fill, int color) throws TinkerforgeException;

    public void brickletEPaper296x128SetUpdateMode(int updateMode) throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetUpdateMode() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetDisplayType() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetDisplayDriver() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128ReadUID() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetStatusLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetSPITFPErrorCount() throws TinkerforgeException;

    public void brickletEPaper296x128Reset() throws TinkerforgeException;

    public Map<String, Object> brickletEPaper296x128GetIdentity() throws TinkerforgeException;;
}
