/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Industrial Counter Bricklet.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletIndustrialCounterActions {

    public Map<String, Object> brickletIndustrialCounterGetCounter(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetAllCounter() throws TinkerforgeException;

    public void brickletIndustrialCounterSetCounter(int channel, long counter) throws TinkerforgeException;

    public void brickletIndustrialCounterSetAllCounter(long[] counter) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetSignalData(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetAllSignalData() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetCounterActive(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetAllCounterActive() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetCounterConfiguration(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetChannelLEDConfig(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterReadUID() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetStatusLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetSPITFPErrorCount() throws TinkerforgeException;

    public void brickletIndustrialCounterReset() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialCounterGetIdentity() throws TinkerforgeException;;
}
