/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2021-12-16.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Industrial Digital Out 4 Bricklet 2.0.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletIndustrialDigitalOut4V2Actions {

    public void brickletIndustrialDigitalOut4V2SetValue(boolean[] value) throws TinkerforgeException;

    public void brickletIndustrialDigitalOut4V2SetSelectedValue(int channel, boolean value) throws TinkerforgeException;

    public void brickletIndustrialDigitalOut4V2SetMonoflop(int channel, boolean value, long time) throws TinkerforgeException;

    public void brickletIndustrialDigitalOut4V2SetPWMConfiguration(int channel, long frequency, int dutyCycle) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetValue() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetMonoflop(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetChannelLEDConfig(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetPWMConfiguration(int channel) throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2ReadUID() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetStatusLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetSPITFPErrorCount() throws TinkerforgeException;

    public void brickletIndustrialDigitalOut4V2Reset() throws TinkerforgeException;

    public Map<String, Object> brickletIndustrialDigitalOut4V2GetIdentity() throws TinkerforgeException;;
}
